#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef struct biro
{
	char ime[100];
	char mesto[100];
	int ss,sp;
	struct biro *sledeci;
}lista;

lista *dodaj(lista *temp,lista *p)
{
	if(!p)
	{
		p=temp;
		p->sledeci=NULL;
	}
	else
	{
		temp->sledeci=p;
		p=temp;
	}
	return p;
}

lista *formiraj(FILE *f)
{
	int i=0,k,n,broj;
	lista *p=NULL;
	fscanf(f,"%d",&k);
	fgetc(f);
	while(i<k)
	{
		lista *temp;
		temp=malloc(sizeof(lista));
		fgets(temp->ime,100,f);
		fgets(temp->mesto,100,f);
		fscanf(f,"%d",&temp->ss);
		fscanf(f,"%d",&temp->sp);
		fgetc(f);
		if(temp->ss>=3 && temp->ss<=8)
		{
			i++;
			p=dodaj(temp,p);
		}
	}	
	return p;
}

void ispis(lista *p)
{
	while(p)
	{
		printf("Ime: %sSS: %d, SP: %d, Mesto: %s",p->ime,p->ss,p->sp,p->mesto);
		p=p->sledeci;
	}
}

int strucna(int sp,lista *p)
{
	int max=0;
	while(p)
	{
		if(p->sp==sp && max<p->ss)
		max=p->ss;
		p=p->sledeci;
	}
	return max;
}
	
lista *brisi(lista *p)
{
	lista *pom,*t;
	while(p && p->ss!=strucna(p->sp,p))
	{
		pom=p;
		p=p->sledeci;
		free(pom);
	}
	t=pom=p;
	p=p->sledeci;
	while(p)
	{
		if(p->ss!=strucna(p->sp,t))
		{
			pom->sledeci=p->sledeci;
			free(p);
			p=pom->sledeci;
		}
		else
		{
			pom=p;
			p=p->sledeci;
		}
	}
	return t;
}
main(int argc, char **argv)
{
	lista *p=NULL;
	int sp;
	if(argc!=2)
	{
		printf("unesite ime datoteke iz koje se cita\n");
		exit(0);
	}
	FILE *f=fopen(argv[1],"r");
	p=formiraj(f);
	fclose(f);
	ispis(p);
	printf("Unesite 'Sifru posla': ");
	scanf("%d",&sp);
	printf("\nNajveca strucna sprema je: %d\n",strucna(sp,p));
	p=brisi(p);
	printf("\nLista najboljih kandidata:\n");
	ispis(p);
}
	
	

	
