#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct _CVOR CVOR;

struct _CVOR
{
	char ime[30];
	int rodj;
	int smrt;
	struct _CVOR *levi;
	struct _CVOR *desni;
};

CVOR *element()
{
	CVOR *t;
	t = (CVOR *) malloc(sizeof(CVOR));
	t->levi=t->desni=NULL;
	return t;
}

void dodaj(CVOR **k, CVOR *n)
{
	CVOR *t = *k;
	
	if (!t)
		*k = n;
	else
	{
		int rk, rn;
		rk = t->smrt - t->rodj;
		rn = n->smrt - n->rodj;
		
		if (rk < rn)
			dodaj(&t->desni, n);
		else
			dodaj(&t->levi,n);
	}
}

CVOR *form()
{
	CVOR *k, *nov;
	int i, n;
	char *ime;
	k = NULL;
	
	printf("Unesi n:");
	scanf("%d", &n);
	
	for (i = 0; i < n; i++)
	{
		nov = element();
		printf("Unesi ime");
		scanf("%s", ime);
		strcpy(nov->ime, ime);
		printf("Rodjenje");
		scanf("%d", &nov->rodj);
		printf("Smrt");
		scanf("%d", &nov->smrt);
		
		dodaj(&k, nov);
	}
	
	return k;
}

void ispis(CVOR *g)
{
	if (!g)
		return;
	ispis(g->levi);
	printf("Ime %s, zivot %d\n", g->ime, (g->smrt-g->rodj));
	ispis(g->desni);
}

int broj_g(CVOR *g, int god)
{
	if (!g)
		return 0;
	
	int i = 0, gd;
	gd = g->smrt - g->rodj;
	
	if (gd > god)
		i = broj_g(g->levi, god);
	
	if (gd >= god)
		i++;
	
	i = i + broj_g(g->desni, god);
	
	return i;
}

int main(int argc, char **argv)
{
	CVOR *koren;
	int g;
	koren = form();
	ispis(koren);
	printf("Unesi g");
	scanf("%d", &g);
	printf("Broj naucnika je %d.\n", broj_g(koren, g));
	
	return 0;
}
