#include<stdio.h>
#include<stdlib.h>
#include<string.h>
struct kandidat{
	char ime[50];
	int otp;
	int on;
	int op;
	char komentar[30];
	int balans;
	struct kandidat *levi,*desni;
};
#define novi(x) x=(struct kandidat *)malloc(sizeof(struct kandidat));
int dubina(struct kandidat *p){
	int dl=0,dd=0;
	if(p){
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		if(dl>dd) return ++dl;
		else return ++dd;
	}
	else return 0;
}
void levar(struct kandidat **p){
	struct kandidat *poml,*pomd;
	poml=*p;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
	*p=pomd;
}
void desnar(struct kandidat **p){
	struct kandidat *poml,*pomd;
	pomd=*p;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
	*p=poml;
}
int dodaj(struct kandidat **p,char name[50],int otp,int on,int op){
	struct kandidat *pom,*tren;
	int inkrement,rezultat=0;
	tren=*p;
	novi(pom);
	if(!pom){
		printf("Greska.");
		exit(0);
	}
	strcpy(pom->ime,name);
	pom->otp=otp;
	pom->on=on;
	pom->op=op;
	if(pom->op>5) strcpy(pom->komentar,"Uspesan");
	else strcpy(pom->komentar,"Neuspesan");
	pom->levi=pom->desni=NULL;
	if(!tren){
		*p=pom;
		pom->balans=0;
		rezultat=1;
	}
	else{
		if(((tren->otp+tren->on+tren->op)/3)>((pom->otp+pom->on+pom->op)/3)) inkrement=-dodaj(&(tren->levi),name,otp,on,op);
		else inkrement=dodaj(&(tren->desni),name,otp,on,op);
		pom->balans+=inkrement;
		if((inkrement!=0)&&(tren->balans!=0)){
			if(tren->balans<-1){
				if(tren->levi->balans<0) desnar(&tren);
				else{
					levar(&(tren->levi));
					desnar(&tren);
				}
			}
			else if(tren->balans>1){
				if(tren->desni->balans>0) levar(&tren);
				else{
					desnar(&(tren->desni));
					levar(&tren);
				}
			}
			else rezultat=1;
		}
	}
	*p=tren;
	return rezultat;
}
void ispis(struct kandidat *p){
	if(p){
		if(p->desni) ispis(p->desni);
		printf("%s%d%d%d%s",p->ime,p->otp,p->on,p->op,p->komentar);
		if(p->levi) ispis(p->levi);
	}
}
/*void brisi(struct kandidat **p,struct kandidat **q){
	struct kandidat *pom,*tren;
	pom=*p;
	if(strcmp(pom->komentar,"Uspesan")==0){
		dodaj(p,q)
}*/
main(){
	struct kandidat *koren;
	koren=NULL;
	int i,n,otp,on,op;
	char name[50];
	scanf("%d",&n);
	for(i=0;i<n;i++){
		scanf("%s",name);
		scanf("%d%d%d",&otp,&on,&op);
		dodaj(&koren,name,otp,on,op);
	}
	ispis(koren);
}
