#include<stdio.h>
#include<stdlib.h>
#include<string.h>
struct element {
	char ime[30];
	char mesto[30];
	int strucnasprema;
	int sifraposla;
	struct element*sledeci;
};

struct element*dodaj(struct element*p,char ime[30],char mesto[30],int strucnasprema,int sifraposla)
{
	struct element*pom;
	if (!p)
	{
		p=(struct element*)malloc(sizeof(struct element));
		strcpy(p->ime,ime); strcpy(p->mesto,mesto); p->strucnasprema=strucnasprema;
		p->sifraposla=sifraposla;  p->sledeci=NULL;
	}
	else
	{
		pom=p;
		while (pom->sledeci) pom=pom->sledeci;
		pom->sledeci=(struct element*)malloc(sizeof(struct element));
		pom=pom->sledeci;
		strcpy(pom->ime,ime); strcpy(pom->mesto,mesto); pom->strucnasprema=strucnasprema;
		pom->sifraposla=sifraposla; pom->sledeci=NULL;
	}
	return p;
}

struct element*okreni(struct element*p)
{
	struct element*prethodni=NULL,*trenutni=p,*sledeci;
	while (trenutni)
	{
		sledeci=trenutni->sledeci;
		trenutni->sledeci=prethodni;
		prethodni=trenutni;
		trenutni=sledeci;
	}
	return prethodni;
}

void stampaj(struct element*p)
{
	struct element*pom=p;
	if (!pom) printf("Lista je prazna\n");
	else
	{
		while (pom)
		{
			printf("%s\t%s\t%d\t%d\n",pom->ime,pom->mesto,pom->strucnasprema,pom->sifraposla);
			pom=pom->sledeci;
		}
	}
}

int najveca(struct element*p,int sifra,int maks)
{
	struct element*pom=p;
	while (pom)
	{
		if (sifra==pom->sifraposla)
		 { if (pom->strucnasprema>maks) maks=pom->strucnasprema; }
		pom=pom->sledeci;
	}
	return maks;
}

void obrisi(struct element*p,int rednibroj)
{
	struct element*trenutni=p,*prethodni=NULL;
	int i=1;
	if (!p)
	{
		while (i<rednibroj)
		{
			prethodni=trenutni;
			trenutni=trenutni->sledeci;
			++i;
		}
		if (prethodni==NULL)
		{
			p=trenutni->sledeci;
			free(trenutni);
		}
		else
		{
			prethodni->sledeci=trenutni->sledeci;
			free(trenutni);
		}
		
	}
}

struct element*nadjilose(struct element*p)
{
	int i=1,maks=0;
	struct element *pom=p;
	while (pom)
	{
		maks=najveca(p,pom->sifraposla,maks);
		if (pom->strucnasprema<maks) obrisi(p,i);
		i++;
		pom=pom->sledeci;
	}
	return p;
}

main()
{
	int k,strucnasprema,sifraposla,maks,sifra;
	char ime[30],mesto[30];
	struct element *glava=NULL;
	printf("Unesi k\n");
	scanf("%d",&k);
	getchar();
	while (k)
	{
		printf("Unesi podatke za kandidata\n");
		gets(ime);
		gets(mesto);
		scanf("%d",&strucnasprema);
		scanf("%d",&sifraposla);
		getchar();
		if (strucnasprema<3||strucnasprema>8) printf("Prijava nije korektna\n");
		else
		{
			k=k-1;
			glava=dodaj(glava,ime,mesto,strucnasprema,sifraposla);
		}
		
	}
	glava=okreni(glava);
	printf("Lista je\n");
	stampaj(glava);
	printf("Unesi sifru posla\n");
	scanf("%d",&sifra);
	maks=0;
	maks=najveca(glava,sifra,maks);
	printf("Najveca strucna sprema za tu sifru je %d\n",maks);
	
	glava=nadjilose(glava);
	printf("Nova lista je\n");
	stampaj(glava);
}





















