#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>
struct drvo {
	char ime[30];
	int tezinapesme;
	int nastup;
	int pevanje;
	float prosek;
	char komentar[30];
	int balans;
	struct drvo *levi,*desni;
};

int dubina(struct drvo*p)
{
	int dl=0,dd=0;
	if (p){
		if (p->levi) dl=dubina(p->levi);
		if (p->desni) dd=dubina(p->desni);
		if (dl>dd) return ++dl;
		else return ++dd;
	}
	else return 0;
}

void lrotacija(struct drvo**p)
{
	struct drvo*poml,*pomd;
	poml=*p;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*p=pomd;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void drotacija(struct drvo**p)
{
	struct drvo *poml,*pomd;
	pomd=*p;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*p=poml;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

int dodaj(struct drvo**p,char ime[30],int tezinapesme,int nastup,int pevanje,float prosek,char komentar[30])
{
	int inkrement,rezultat;
	struct drvo*t=*p;
	rezultat=0;
	if (t==NULL)
	{
		t=(struct drvo*)malloc(sizeof(struct drvo));
		strcpy(t->ime,ime);  t->tezinapesme=tezinapesme; t->nastup=nastup; 
		t->pevanje=pevanje; t->prosek=prosek; strcpy(t->komentar,komentar);
		t->levi=t->desni=NULL;
		t->balans=0;
		rezultat=1;
	}
	else
	{
if (t->prosek>prosek) inkrement=dodaj(&(t->desni),ime,tezinapesme,nastup,pevanje,prosek,komentar);
	else inkrement=-dodaj(&(t->levi),ime,tezinapesme,nastup,pevanje,prosek,komentar);
	t->balans+=inkrement;
	if (t->balans&&inkrement)
	{
		if (t->balans<-1)
		{
			if (t->levi->balans<0) drotacija(&t);
			else { lrotacija(&(t->levi)); drotacija(&t); };
		}
		else if (t->balans>1)
		{
			if (t->desni->balans>0) lrotacija(&t);
			else { drotacija(&(t->desni)); lrotacija(&t); }
		}
		else rezultat=1;
	}
	}
	*p=t;
	return rezultat;
}

struct drvo*form()
{
	struct drvo*koren=NULL;
	int i,n,tezinapesme,nastup,pevanje;
	float prosek;
	char ime[30],komentar[30];
	printf("Unesi broj kandidata,tj unesi n\n");
	scanf("%d",&n);
	getchar();
	for (i=0;i<n;i++)
	{
printf("Unesi podatke za %d. kandidata,redom u svakoj liniji ime,tezina,nastup,pevanje\n",i+1);
	gets(ime);
	scanf("%d",&tezinapesme);
	scanf("%d",&nastup);
	scanf("%d",&pevanje);
	getchar();
	if (pevanje>5) strcpy(komentar,"Uspesan");
	else strcpy(komentar,"Neuspesan");
	prosek=((float)(tezinapesme+nastup+pevanje))/3;
	dodaj(&koren,ime,tezinapesme,nastup,pevanje,prosek,komentar);
	}
return koren;
}

void ispis(struct drvo*p)
{
	if (p)
	{
		if (p->levi) ispis(p->levi);
printf("%s\t%d\t%d\t%d\t%5.2f\t%s\n",p->ime,p->tezinapesme,p->nastup,p->pevanje,p->prosek,p->komentar);
		if (p->desni) ispis(p->desni);
	}
	else return;
}

main()
{
	struct drvo*p,*q=NULL;
	p=form();
	ispis(p);
	printf("\n");
}




































