#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct lista{
	char *ime;
	char *mesto;
	int sprema;
	int sifra;
	struct lista *sled;
};

#define novi(x) x=(struct lista*)malloc(sizeof(struct lista))

void dodaj(struct lista **p,char *ime,char *mesto,int sprema,int sifra){
	struct lista *t;
	//~ printf("uso");
	novi(t);
	if(t==NULL){
		printf("greska pri alokaciji\n");
		exit(0);
	}
	t->ime=(char*)malloc(strlen(ime)+1);
	t->mesto=(char*)malloc(strlen(mesto)+1);
	strcpy(t->ime,ime);
	strcpy(t->mesto,mesto);
	t->sprema=sprema;
	t->sifra=sifra;
	if(!(*p)){
		 t->sled=NULL;
		 (*p)=t;
	 }
	 else{
		 t->sled=*p;
		 *p=t;
	 }
	 //~ printf("izaso");
 }
 
 struct lista *napravi(){
	 struct lista *p=NULL;
	 int k,b;
	 char ime[30];
	 char mesto[30];
	 int sprema;
	 int sifra;
	 printf("Unesi broj prijava\n");
	 scanf("%d\n",&k);
	 b=0;
	 while(b<k){
		 scanf("%s",ime);//gets(ime);
		 //~ scanf("\n");
		 scanf("%s",mesto);//gets(mesto);
		 //~ scanf("\n");
		 scanf("%d",&sprema);
		 scanf("%d",&sifra);
		 if((sprema >= 3) && (sprema <= 8)){
			 //~ printf("uso u if");
			 dodaj(&p,ime,mesto,sprema,sifra);
			 b++;
		 }
		
	 }
	 return p;
 }
 
 void ispis(struct lista *p){
	 while(p){
		 printf("%s %s %d %d\n",p->ime,p->mesto,p->sifra,p->sprema);
		 p=p->sled;
	 }
 }
 
int nadji(struct lista *p,int sifra){
	 struct lista *pom;
	 int max;
	 pom=p;
	 while(pom){
		 if(pom->sifra==sifra){ max=pom->sprema; break; }
		 pom=pom->sled;
	 }
	 while(p){
		 if((p->sifra==sifra) && (p->sprema > max)) max=p->sprema;
		 p=p->sled;
	 }
	 return max;
 }
 
void obrisi(struct lista **pret,struct lista *pom,struct lista **p){
	if(!(*pret)){
		(*p)=pom->sled;
		free(pom);
	}
	else{
	   (*pret)->sled=pom->sled;	
	   free(pom);
   }
}

 void brisi(struct lista **p){
	 int max;
	 struct lista *pret=NULL,*pom;
	 pom=*p;
	 while(pom){
		 max=nadji(pom,pom->sifra);
		 if(pom->sprema!=max) obrisi(&pret,pom,p);
		 pret=pom;
		 pom=pom->sled;
	 }
 }
		 

		 
 
 main(){
	 struct lista *p;
	 int max;
	 int sifra;
	 p=napravi();
	 ispis(p);
	 printf("Unesi sifru \n");
	 scanf("%d",&sifra);
	 max=nadji(p,sifra);
	 printf("Najveca strucna sprema: %d\n",max);
	 brisi(&p);
	 ispis(p);
 }
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
		 
		 
		 
		 
		 
		 
		 
		 
		 
		 
		 
		 
		 
