#include<stdio.h>
#include<stdlib.h>

struct naucnik{
	char ime[30];
	int godina_rodjenja;
	int godina_smrti;
	struct naucnik *levi, *desni;
	};
	
#define obezbedi(x) x=(struct naucnik *)malloc(sizeof(struct naucnik))

int duzina_zivota(struct naucnik * temp){
	return (temp->godina_smrti - temp->godina_rodjenja);
	}

void dodaj(struct naucnik **koren, struct naucnik *temp){
	struct naucnik *q, *p;
	int zivottemp, zivotp;
	zivottemp=duzina_zivota(temp);
	
	p=*koren;
	q=NULL;
	
	while (p){
		q=p;
		zivotp=duzina_zivota(p);
		if(zivottemp<zivotp) p=p->levi;
		else p=p->desni;
		}
	if(!q) *koren=temp;
	else{
		zivotp=duzina_zivota(q);
		if(zivottemp<zivotp) q->levi=temp;
		else q->desni=temp;
		}
		
	}
	
void formiraj(struct naucnik **koren, FILE *f){
	struct naucnik *temp;
	int N, i;
	
	fscanf(f, "%d", &N);
	
	for(i=0; i<N; i++){
		obezbedi(temp);
		if(!temp){
			printf("Greska pri alokaciji memorije!\n");
			exit(1);
			}
		fscanf(f, "%s", temp->ime);
		fscanf(f, "%d", &temp->godina_rodjenja);
		fscanf(f, "%d", &temp->godina_smrti);
		
		dodaj(koren, temp);
		}
	}
	
	
	
void ispis(struct naucnik *koren){
	if(koren){
		if(koren->levi) ispis(koren->levi);
		
		printf("%s    ", koren->ime);
		printf("%d - %d\n", koren->godina_rodjenja, koren->godina_smrti);
		
		if(koren->desni) ispis(koren->desni);
		}
	}	
	

int br_naucnika (struct naucnik *koren, int G){
	int zivot;
	
	while(koren){
		zivot=duzina_zivota(koren);
		if(zivot>=G) 
			return 1 + br_naucnika(koren->desni, G) + br_naucnika(koren->levi, G);
		else return 0 + br_naucnika(koren->desni, G) + br_naucnika(koren->levi, G);
	}
}
main(int argc, char *argv[]){
	FILE *f;
	f=fopen(argv[1], "r");
	struct naucnik *koren;
	koren=NULL;
	
	if(!f){
		printf("Greska pri otvaranju datoteke!\n");
		exit(1);
		}
		
	formiraj(&koren, f);
	
	ispis(koren);
	
	int G;
	printf("Unesite broj godina za testiranje: \n");
	scanf("%d", &G);
	
	printf("Broj naucnika koji su ziveli bar %d godina je %d ", G, br_naucnika(koren,G));
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
