#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct cvor {
	char ime[15];
	int ocenatp;
	int ocenan;
	int ocenap;
	char kom[10];
	int balans;
	struct cvor *l, *d;
}dr;


int dubina(dr *p){
	int dl=0, dd=0;
	if (p){
		if(p->l) dl=dubina(p->l);
		if(p->d) dd=dubina(p->d);
		if(dl>dd)
		return ++dl;
		else return ++dd;
	}
	else return 0;
}


void lrotacija(dr **t){
	dr *pom,*p=*t;
	pom=p->d->l;
	p->d->l=p;
	p=p->d;
	p->l->d=pom;
	*t=p;
	
	p->balans=dubina(p->d)-dubina(p->l);
	p->l->balans=dubina(p->l->d)-dubina(p->l->l);
}


void drotacija(dr **t){
	dr *pom,*p=*t;
	pom=p->l->d;
	p->l->d=p;
	p=p->l;
	p->d->l=pom;
	*t=p;
	
	p->balans=dubina(p->d)-dubina(p->l);
	p->d->balans=dubina(p->d->d)-dubina(p->d->l);
}


int dodaj(dr **p,dr *temp){
	int balans=0,inc=0;
	if(!(*p)) {
		*p=temp;
		(*p)->balans=0;
		balans=1;
	}
	else {
		if (strcmp(temp->ime,(*p)->ime) < 0)
		inc=-dodaj(&((*p)->l),temp);
		else
		inc=dodaj(&((*p)->d),temp);
		(*p)->balans+=inc;
		if(inc!=0 && (*p)->balans!=0){
			if ((*p)->balans < -1){
				if((*p)->l->balans<0)
				drotacija(&(*p));
				else {
					lrotacija(&(*p)->l);
					drotacija(&(*p));
				}
			}
			if((*p)->balans>1)
			{
				if((*p)->d->balans > 0)
				lrotacija(&(*p));
				else {
					drotacija(&(*p)->d);
					lrotacija(&(*p));
				}
			}
		else balans=1;
	}
	return balans;
}

void ispis(dr *p){
	if(p)
	{
		ispis(p->l);
		printf("%s balans:%d\n",p->ime,p->balans);
		ispis(p->d);
	}
}

					
		
		
		
		
		
		
		
		
	
	
	
