#include <stdlib.h>
#include <stdio.h>
#include <string.h>


typedef struct avl
{
char ime[100];
int ocena_tezine;
int ocena_nastupa;
int ocena_pevanja;
char komentar[100];
int broj;
int balans;
struct avl * levi;
struct avl * desni;
}avl;


int dubina(avl * g)
{
int dd=0,dl=0;
if(g->desni) dd = dubina(g->desni);
if(g->levi) dl = dubina(g->desni);
if(dd > dl) return dd++;
else return dl++;
}

void drotacija(avl ** g)
{
avl * poml,* pomd;
poml=(*g)->levi;
pomd=(*g);
pomd->levi = poml->desni;
poml->desni = pomd;
(*g)=poml;

poml->balans = dubina(poml->desni)-dubina(poml->levi);
pomd->balans = dubina(pomd->desni)-dubina(pomd->levi);
}
void lrotacija(avl ** g)
{
avl * poml,* pomd;
pomd=(*g)->desni;
poml=(*g);
poml->desni = pomd->levi;
pomd->levi = poml;
(*g)=pomd;

poml->balans = dubina(poml->levi)-dubina(poml->desni);
pomd->balans = dubina(pomd->levi)-dubina(pomd->desni);
}


int dodaj(avl ** g,avl * tmp)
{
int inkrement,rezultat = 0;
avl * t = *g;

if(t == NULL)
 {
	t = tmp;
	t->balans = 0;
	rezultat = 1;	
 } 
else
 {
  if(tmp ->broj < t->broj)
    inkrement = -dodaj(&(t->levi),tmp);
  else
     inkrement = dodaj(&(t->desni),tmp);
  t->balans +=inkrement;
  if(t->balans != 0 && inkrement !=0)
 	{
	if(t->balans < -1)
        	{
		if(t->levi->balans < 0)
 		     drotacija(&t);
		else
  		     {
		     lrotacija(&(t->levi));
		     drotacija(&t);
		     }	
		}
	else
	    if(t->balans > 1)
 		    {
		    if(t->desni->balans >0)	
 		     lrotacija(&t);
		     else
			{
			drotacija(&(t->desni));
			lrotacija(&t);
			}	
	             }	
	else rezultat = 1;
     }
}
*g=t;
return rezultat;
}
void ispis(avl * g)
{
printf("ssssssssssssss %d  ",g->ocena_pevanja);
if(g)
 {
  ispis(g->levi);
  printf("%s %d %d %d <%d>",g->ime,g->ocena_tezine,g->ocena_nastupa,g->ocena_pevanja,g->balans);
  ispis(g->desni);
 }
}
void Unos(avl ** root)
{
int n,i;
avl * p = (*root);
printf("Unesi N");
scanf("%d",&n);
for(i=0;i<n;i++)
{
avl * tmp = (avl *)malloc(sizeof(avl));
printf("Unesi ime:");
scanf("%s",tmp->ime);
printf("Unesi ocenu tezine pesme");
scanf("%d",&tmp->ocena_tezine);
printf("Unesi ocenu nastupa:");
scanf("%d",&tmp->ocena_nastupa);
printf("Unesi ocenu pevanja");
scanf("%d",&tmp->ocena_pevanja);
if(tmp->ocena_pevanja > 5)
  strcpy(tmp->komentar,"uspesan");
else
  strcpy(tmp->komentar,"neuspesan"); 
int srednja = ((tmp->ocena_tezine + tmp->ocena_nastupa + tmp->ocena_pevanja)/3);
tmp->broj = srednja;
dodaj(&p,tmp);
}
*root = p;
}
main()
{
avl * root=NULL;
Unos(&root);
ispis(root);
}










