#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define novi(x) x=(struct drvo *)malloc(sizeof(struct drvo))

enum{CRVENA,CRNA};

struct drvo {
	char ime[50];
	 int ocenatez;
	 int ocenanas;
	 int ocenapev;
	 int boja;
	 float srednja;
	 struct drvo *levi,*desni,*roditelj;
	char kom[20];
	};
	
void lrotacija(struct drvo **p){
	struct drvo *pom,*pom1;
	pom=*p;
	pom1=pom->desni;
	pom->desni=pom1->levi;
	if (pom1->levi) pom1->levi->roditelj=pom;
	pom1->roditelj=pom->roditelj;
	if (pom->roditelj)
		if (pom==pom->roditelj->levi) pom->roditelj->levi=pom1;
		else pom->roditelj->desni=pom1;
		pom1->levi=pom;
		pom->roditelj=pom1; 
		*p=pom1;
	}
	
void drotacija(struct drvo **p){
	struct drvo *pom,*pom1;
	pom=*p;
	pom1=pom->levi;
	pom->levi=pom1->desni;
	if (pom1->desni) pom1->desni->roditelj=pom;
	pom1->roditelj=pom->roditelj;
	if (pom->roditelj)
		if (pom==pom->roditelj->levi) pom->roditelj->levi=pom1;
		else pom->roditelj->desni=pom1;
		pom1->desni=pom;
		pom->roditelj=pom1;
		*p=pom1;
	
	}
	
	void bojefix(struct drvo **p, struct drvo *z){
		struct drvo *pom,*pom1;
		while((z->roditelj) && (z->roditelj->boja=CRVENA)){
			if (z->roditelj==z->roditelj->roditelj->levi){
				pom=z->roditelj->roditelj->desni;
				if ((pom!=NULL) && (pom->boja==CRVENA)){
					pom->boja=CRNA;
					z->roditelj->boja=CRNA;
					z->roditelj->roditelj->boja=CRVENA;
					z=z->roditelj->roditelj;
					}
					else {
						if (z==z->roditelj->desni){
							z=z->roditelj;
							lrotacija(&z);
							if (!z->roditelj) *p=z;
							z=z->levi;
							}
							z->roditelj->boja=CRNA;
							z->roditelj->roditelj->boja=CRVENA;
							pom1=z->roditelj->roditelj;
							drotacija(&pom1);
							if (!pom1->roditelj) *p=pom1;
						}
				}
				else {
					pom=z->roditelj->roditelj->levi;
					if ((pom!=NULL) && (pom->boja==CRVENA)){
						pom->boja=CRNA;
						z->roditelj->roditelj->boja=CRVENA;
						z->roditelj->boja=CRNA;
						z=z->roditelj->roditelj;
					}
					else {
						if (z==z->roditelj->levi){
							z=z->roditelj;
							drotacija(&z);
							if (!z->roditelj) *p=z;
							z=z->desni;
							}
							z->roditelj->boja=CRNA;
							z->roditelj->roditelj->boja=CRVENA;
							pom1=z->roditelj->roditelj;
							lrotacija(&pom1);
							if (!pom1->roditelj) *p=pom1;
						}
			}
		} (*p)->boja=CRNA;
	}
	
void dodaj(struct drvo **p,struct drvo *z){
	struct drvo *pom,*pom1;
	pom=*p;
	pom1=NULL;
	while(pom){
		pom1=pom;
		if (pom->srednja<z->srednja) pom=pom->desni;
		else pom=pom->levi;
		}
		z->roditelj=pom1;
		if (!pom1) *p=z;
		else {
			if (pom1->srednja<z->srednja) pom1->desni=z;
			else pom1->levi=z;
			}
			bojefix(p,z);
	}


struct drvo *form(){
	struct drvo *z=NULL;
	struct drvo *p=NULL;
	int n;
	char ime1[50];
	int ocenatez1;
	int ocenanas1;
	int ocenapev1;
	
	printf("uneti n:");
	scanf("%d",&n);
	while(n){
		printf("uneti ime:");
		scanf("%s",ime1);
		printf("uneti ocenu tezine");
		scanf("%d",&ocenatez1);
		printf("uneti ocenu nastupa:");
		scanf("%d",&ocenanas1);
		printf("uneti ocenu pevanja");
		scanf("%d",&ocenapev1);
		novi(z);
		z->levi=z->desni=z->roditelj=NULL;
		z->boja=CRVENA;
		z->ocenanas=ocenanas1;
		z->ocenapev=ocenapev1;
		z->ocenatez=ocenatez1;
		z->srednja=((z->ocenanas+z->ocenapev+z->ocenatez)/3);
		strcpy(z->ime,ime1);
		if (z->ocenapev>5) strcpy(z->kom,"uspesan");
		else strcpy(z->kom,"neuspesan");
		dodaj(&p,z);
		n--;
		}
		return p;
	}
	
	void stampaj(struct drvo *p){
		if (p!=NULL){
			stampaj(p->desni);
			printf("%s\t%d\t%d\t%d\t%s\t",p->ime,p->ocenanas,p->ocenapev,p->ocenatez,p->kom);
			if (p->boja==CRVENA) printf("(CRVENA)\n");
			else printf("(CRNA)\n");
			stampaj(p->levi);
			}
		}
	

	void obrisi(struct drvo *p,struct drvo **q, char ime1[],char ime2[] ){
		struct drvo *pom;
		
		if (p!=NULL)
				if ((strcmp(p->kom,"uspesan")==0) || (strcmp(p->ime,ime1)==0) || (strcmp(p->ime,ime2)==0)){
					novi(pom);
					pom->ocenanas=p->ocenanas;
					pom->ocenapev=p->ocenapev;
					pom->ocenatez=p->ocenatez;
					pom->levi=pom->desni=pom->roditelj=NULL;
					pom->boja=CRVENA;
					strcpy(pom->kom,p->kom);
					strcpy(pom->ime,p->ime);
					pom->srednja=p->srednja;
					dodaj(q,pom);
					obrisi(p->levi,q,ime1,ime2);
					obrisi(p->desni,q,ime1,ime2);
					}
					else {
					obrisi(p->levi,q,ime1,ime2);
					obrisi(p->desni,q,ime1,ime2);
						}
		}
			int main(){
		struct drvo *p=NULL;
		struct drvo *q=NULL;
		char ime1[50];
		char ime2[50];
		p=form();
		stampaj(p);
		printf("uneti ime1");
		scanf("%s",ime1);
		printf("uneti ime2");
		scanf("%s",ime2);
		obrisi(p,&q,ime1,ime2);
		stampaj(q);
		}
		
