#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct cvor
{
	char *rec;
	int *ocena_t;
	int *ocena_n;
	int *ocena_p;
	int balans;
	struct cvor *l,*d;
}dr;

int dubina(dr *p)
{
	int dl=0,dd=0;
	if(p)
	{
		if(p->l) dl=dubina(p->l);
		if(p->d) dd=dubina(p->d);
		if(dl>dd)
		return ++dl;
		else
		return ++dd;
	}
	else
	return 0;
}

void lrotacija(dr **t)
{
	dr *pom,*p=*t;
	pom=p->d->l;
	p->d->l=p;
	p=p->d;
	p->l->d=pom;
	*t=p;
	
	p->balans=dubina(p->d)-dubina(p->l);
	p->l->balans=dubina(p->l->d)-dubina(p->l->l);
}

void drotacija(dr **t)
{
	dr *pom,*p=*t;
	pom=p->l->d;
	p->l->d=p;
	p=p->l;
	p->d->l=pom;
	*t=p;
	
	p->balans=dubina(p->d)-dubina(p->l);
	p->d->balans=dubina(p->d->d)-dubina(p->d->l);
}

int dodaj(dr **p, char rec[])
{
	int balans=0,inc=0;
	if(!(*p))
	{
		dr *temp;
		temp=malloc(sizeof(dr));
		temp->rec=malloc(strlen(rec)+1);
		strcpy(temp->rec,rec);
		temp->l=NULL;
		temp->d=NULL;
		*p=temp;
		(*p)->balans=0;
		balans=1;
	}
	else
	{
		if(strcmp(rec,(*p)->rec)<0)
		inc=-dodaj(&((*p)->l),rec);
		else
		inc=dodaj(&((*p)->d),rec);
		
		(*p)->balans+=inc;
		if(inc!=0 && (*p)->balans!=0)
		{
			if((*p)->balans<-1)
			{
				if((*p)->l->balans<0)
				drotacija(&(*p));
				else
				{
					lrotacija(&(*p)->l);
					drotacija(&(*p));
				}
			}
			if((*p)->balans>1)
			{
				if((*p)->d->balans>0)
				lrotacija(&(*p));
				else
				{
					drotacija(&(*p)->d);
					lrotacija(&(*p));
				}
			}
			else
			balans=1;
		}
	}
return balans;
}

dr *form()
{
	dr *p=NULL;
	int i,n;
	char s[20];
	
	scanf("%d",&n);
	for(i=0;i<n;i++)
	{
		scanf("%s",s);
		dodaj(&p,s);
	}
	return p;
}

void ispis(dr *p)
{
	if(p)
	{
		printf("%s balans: %d\n",p->rec,p->balans);
		ispis(p->l);
	}
}

dr *brisi(dr *p,char *k,dr *q)
{
	if(p)
	{
		if(p->rec[0]!=k[0])
		dodaj(&q,(p->rec));
		q=brisi(p->l,k,q);
		q=brisi(p->d,k,q);
		free(p);
	}
	else
	return q;
}

main()
{
	char k[20];
	dr *p=NULL, *q=NULL;
	p=form();
	scanf("%s",k);
	ispis(p);
	p=brisi(p,k,q);
	printf("\n");
	ispis(p);
}
