#include<stdio.h>
#include<stdlib.h>
#include<string.h>

enum {CRVENO,CRNO};

struct drvo{
char ime[50];
int ocena_pes,ocena_nas,ocena_pev,boja;
float srednja;
char komentar[15];
struct drvo *roditelj,*levi,*desni; };

#define novi(x) x=(struct drvo *)malloc(sizeof(struct drvo))
int n;

void lrotacija(struct drvo **p){
 struct drvo *x,*y;
 x=*p;
 y=x->desni;
 x->desni=y->levi;
 if(y->levi) y->levi->roditelj=x;
 y->roditelj=x->roditelj;
 if(x->roditelj)
  if(x==x->roditelj->levi) x->roditelj->levi=y;
		      else x->roditelj->desni=y;
 x->roditelj=y;
 y->levi=x;
 *p=y;
}

void drotacija(struct drvo **p){
 struct drvo *x,*y;
 x=*p;
 y=x->levi;
 x->levi=y->desni;
 if(y->desni) y->desni->roditelj=x;
 y->roditelj=x->roditelj;
 if(x->roditelj)
  if(x==x->roditelj->levi) x->roditelj->levi=y;
		      else x->roditelj->desni=y;
 x->roditelj=y;
 y->desni=x;
 *p=y;
}

void bojefix(struct drvo **koren,struct drvo *z){
struct drvo *y,*deda;
 while((z->roditelj)&&(z->roditelj->boja==CRVENO)){
  if(z->roditelj==z->roditelj->roditelj->levi){
   y=z->roditelj->roditelj->desni;
   if((y)&&(y->boja==CRVENO)){
    				z->roditelj->boja=CRNO;
    				y->boja=CRNO;
    				z=y->roditelj;
    				z->boja=CRVENO;
		             }
  else {
   if(z==z->roditelj->desni){
		z=z->roditelj;
		lrotacija(&z);
		if(z->roditelj==NULL) (*koren)=z;
		z=z->levi;  }
	z->roditelj->boja=CRNO;
	deda=z->roditelj->roditelj;
	deda->boja=CRVENO;
 	drotacija(&deda);
	if(deda->roditelj==NULL) (*koren)=deda;
       }
					      }
else {
 y=z->roditelj->roditelj->levi;
 if((y)&&(y->boja==CRVENO)) {
 				y->boja=CRNO;
 				z->roditelj->boja=CRNO;
 				z=y->roditelj;
 				z->boja=CRVENO; 
			    }
 else {
  if(z==z->roditelj->levi){
		z=z->roditelj;
		drotacija(&z);
		if(z->roditelj==NULL) (*koren)=z;
		z=z->desni;}
	z->roditelj->boja=CRNO;
	deda=z->roditelj->roditelj;
	deda->boja=CRVENO;
	lrotacija(&deda);
	if(deda->roditelj==NULL) (*koren)=deda; }
    }
  }
(*koren)->boja=CRNO;
}

void dodaj(struct drvo **koren,struct drvo *z){
 struct drvo *pom1, *pom2;
 pom1=*koren;
 pom2=NULL;
 if(!(*koren)) (*koren)=z;
 else {
  while(pom1){
		pom2=pom1;
		if(z->srednja<pom1->srednja) pom1=pom1->levi;
					else pom1=pom1->desni;
	     }
  if(z->srednja<pom2->srednja) pom2->levi=z;
			  else pom2->desni=z;
  z->roditelj=pom2;
      }
 
 bojefix(koren,z);
 
}


struct drvo *form(){
struct drvo *koren,*pom;
koren=NULL; int i;
printf("Unesi n:\n"); scanf("%d",&n);
for(i=0;i<n;i++)
 {
  novi(pom);
  getchar();
  printf("\nunesi ime %d. kandidata: ",i+1);scanf("%s",pom->ime);
  printf("Unesi ocenu tezine pesme:\n");scanf("%d",&pom->ocena_pes);
  printf("Unesi ocenu nastupa:\n");scanf("%d",&pom->ocena_nas);
  printf("Unesi ocenu pevanja:\n");scanf("%d",&pom->ocena_pev);
  pom->boja=CRVENO;
  pom->levi=pom->desni=pom->roditelj=NULL;
  pom->srednja=(pom->ocena_pes+pom->ocena_nas+pom->ocena_pev)/3;
  if(pom->ocena_pev>5) strcpy(pom->komentar,"Uspesan");
		else strcpy(pom->komentar,"Neuspesan");
  dodaj(&koren,pom);
 }
 return koren;
}


void ispis(struct drvo *p){
 if(p){
  ispis(p->desni);
  printf("\nime: %s;\tocena tez pes: %d;\tocena nastupa: %d;\tocena pevanja: %d;\tsrednja ocena: %7.2f;\tkomentar: %s;\t",p->ime,p->ocena_pes,p->ocena_nas,p->ocena_pev,p->srednja,p->komentar);
  if(p->boja==CRVENO) printf("CRVENO\n");
 		else printf("CRNO\n");

  ispis(p->levi);
      }
}

void brisi(struct drvo *koren,char *pet,char *deset,struct drvo **novii){
struct drvo *pom1,*pom2;
 if(koren){
  if(strcmp(koren->ime,pet)==0)
     koren->srednja=(koren->ocena_pes+koren->ocena_nas+koren->ocena_pev+5)/4;
  if(strcmp(koren->ime,deset)==0)
     koren->srednja=(koren->ocena_pes+koren->ocena_nas+koren->ocena_pev+10)/4;
   if((strcmp(koren->komentar,"Uspesan")==0)||(((strcmp(koren->ime,pet)==0)||(strcmp(koren->ime,deset)==0))&&(koren->srednja>5))) {
  novi(pom1);
  strcpy(pom1->ime,koren->ime);
  pom1->ocena_pes=koren->ocena_pes;
  pom1->ocena_pev=koren->ocena_pev;
  pom1->ocena_nas=koren->ocena_nas;
  pom1->boja=CRVENO;
  pom1->levi=pom1->desni=pom1->roditelj=NULL;
  pom1->srednja=koren->srednja;
  strcpy(pom1->komentar,koren->komentar);
  dodaj(novii,pom1);
  brisi(koren->levi,pet,deset,novii);
  brisi(koren->desni,pet,deset,novii);
}
 else
{
  brisi(koren->levi,pet,deset,novii);
  brisi(koren->desni,pet,deset,novii);
}
}
}

main(){
struct drvo *koren,*novii; char s1[20],s2[20];
koren=NULL; novii=NULL;
koren=form();
ispis(koren);
printf("unesi imena nagradjenih:\n");
scanf("%s%s",s1,s2);
brisi(koren,s1,s2,&novii);
ispis(novii);
}







