#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

struct kandidat{
	char ime[50],mesto[50];
	int strucna_sprema,sifra_posla;
	struct kandidat *sled;	
};

struct kandidat *brisi(struct kandidat *glava,struct kandidat *pom);

struct kandidat *dodaj(struct kandidat *glava,char ime[],char mesto[],int strucna,int sifra){
	struct kandidat *novi,*pom=glava;
	novi=(struct kandidat *)malloc(sizeof(struct kandidat));
	strcpy(novi->ime,ime);
	strcpy(novi->mesto,mesto);
	novi->strucna_sprema=strucna;
	novi->sifra_posla=sifra;
	novi->sled=NULL;
	
	if(glava==NULL)
		glava=novi;
	else{
		while(pom->sled!=NULL) pom=pom->sled;
		pom->sled=novi;
	}
	return glava;
}

struct kandidat *formiraj(){
	int k,strucna,sifra,i;
	char ime[50],mesto[50];
	struct kandidat *glava=NULL;
	printf("Unesite k: ");
	scanf("%d",&k);
	
	while(k<1){
		printf("\nK mora da bude vece od 0.\nUnesite k: ");
		scanf("%d",&k);
	}
	for(i=1;i<=k;){
		printf("\nUnesite ime kandidata: ");
		getchar();
		gets(ime);
		printf("Unesite njegovo mesto: ");
		gets(mesto);
		printf("Unesite njegovu strucnu spremu: ");
		scanf("%d",&strucna);
		printf("Unesite sifru posla: ");
		scanf("%d",&sifra);
		if(strucna>=3 && strucna <=8){
			glava=dodaj(glava,ime,mesto,strucna,sifra);
			i++;
		}
		else printf("\nKandidat ne zadovoljava uslove\n");
	}
	return glava;
}

/*void ispis(struct kandidat *glava){
	while(glava!=NULL){
		printf("\nIme kandidata: ");
		printf(glava->ime);
		printf("\nNjegovo mesto: ");
		printf(glava->mesto);
		printf("\nNjegova strucna sprema: %d\nSifra posla: %d\n",glava->strucna_sprema,glava->sifra_posla);
		glava=glava->sled;
	}	
}*/

void ispis(struct kandidat *glava){
	if(glava==NULL) {
		printf("Lista je prazna.\n");
		return;
	}
	int brojac=0,i,j;
	struct kandidat *pom=glava;
	while(pom!=NULL) {
		brojac++;
		pom=pom->sled;
	}
	
	for(i=brojac;i>=1;i--){
		pom=glava;
		for(j=1;j<i;j++) pom=pom->sled;
		printf("\nIme kandidata: ");
		printf(pom->ime);
		printf("\nNjegovo mesto: ");
		printf(pom->mesto);
		printf("\nNjegova strucna sprema: %d\nSifra posla: %d\n",pom->strucna_sprema,pom->sifra_posla);
	}
	
}

int najvecass(struct kandidat *glava,int sifra){
	int najveca=0;
	while(glava!=NULL){
		if((glava->sifra_posla==sifra) && (glava->strucna_sprema>najveca))
			najveca=glava->strucna_sprema;
		glava=glava->sled;
	}
	return najveca;
}


struct kandidat *brisanje(struct kandidat *glava){
	struct kandidat *pom=glava,*pom2=pom->sled;
	while(pom!=NULL){
		pom2=pom->sled;
		if(pom->strucna_sprema<najvecass(glava,pom->sifra_posla))
			glava=brisi(glava,pom);
		pom=pom2;
	}
	return glava;
}

struct kandidat *brisi(struct kandidat *glava,struct kandidat *pom){
	struct kandidat *pred=glava;
	if(pom==glava){
		glava=glava->sled;
		free(pom);
	}
	else{
		while(pred->sled!=pom)
			pred=pred->sled;
		pred->sled=pom->sled;
		free(pom);
	}
	return glava;
}

int main(){
	struct kandidat *glava;
	int najveca=0,sifra;
	glava=formiraj();
	printf("\nLista pre brisanja:\n");
	ispis(glava);
	printf("\nUnesite sifru: ");
	scanf("%d",&sifra);
	najveca=najvecass(glava,sifra);
	if(najveca==0) printf("\nNema prijavljenih kandidata za dati posao.\n");
	else printf("\nNajveca strucna sprema za taj posao je %d\n",najveca);
	printf("\nLista najboljih kandidata:\n");
	glava=brisanje(glava);
	ispis(glava);
	return 0;
}


