#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef struct dr
{
	char ime[30];
	int rodjen,umro;
	struct dr *levo,*desno;
}drvo;

int dodaj(drvo **p, drvo *temp)
{
	if((*p)==NULL)
	{
		(*p)=temp;
		(*p)->levo=NULL;
		(*p)->desno=NULL;
	}
	else
	{
		float a,b;
		a=temp->umro-temp->rodjen;
		b=(*p)->umro-(*p)->rodjen;
		if(a < b)
		dodaj(&(*p)->levo,temp);
		else
		dodaj(&(*p)->desno,temp);
	}
}


drvo *form(FILE *f)
{
	drvo *p=NULL;
	int n,i;
	fscanf(f,"%d",&n);
	for(i=0;i<n;i++)
	{
		drvo *temp;
		temp=malloc(sizeof(drvo));
		fscanf(f,"%s",temp->ime);
		fscanf(f,"%d%d",&temp->rodjen,&temp->umro);		
		dodaj(&p,temp);
	}
	return p;
}

void ispis(drvo *p)
{
	if(p)
	{
		ispis(p->levo);
		printf("Ime:%s ziveo: %d\n",p->ime,(p->umro-p->rodjen));
		ispis(p->desno);
	}
}

void barg(drvo *p,int g,int *br)
{
	if(p)
	{
		barg(p->desno,g,br);
		int	b=(p->umro-p->rodjen);
		if(g>b)
		{
			printf("Broj naucnika: %d\n",(*br));
			exit(0);
		}
		else
		(*br)++;
		barg(p->levo,g,br);
	}
}
main(int argc,char **argv)
{
	int g;
	int b=0;
	if(argc!=2)
	{
		printf("unesite ime datoteke iz koje se cita\n");
		exit(0);
	}
	FILE *f=fopen(argv[1],"r");
	drvo *p=NULL;
	p=form(f);
	ispis(p);
	printf("Unesite G:");
	scanf("%d",&g);
	barg(p,g,&b);
	printf("Broj naucnika: %d\n",b);

}
