#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


struct drvo{
	char *ime;
	int opesm;
	int onast;
	int opev;
	char *kom;
	struct drvo *levi,*desni;
	int balans;
};

#define novi(x) x=(struct drvo*)malloc(sizeof(struct drvo))

int dubina(struct drvo *p){
	int dd=0,dl=0;
	if(p){
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		if(dd>dl) return ++dd;
		else return ++dl;
	}
	else return 0;
}

void lrotacija(struct drvo **p){
	struct drvo *poma,*pomb;
	poma=*p;
	pomb=poma->desni;
	poma->desni=pomb->levi;
	pomb->levi=poma;
	*p=pomb;
	poma->balans=dubina(poma->desni)-dubina(poma->levi);
	pomb->balans=dubina(pomb->desni)-dubina(pomb->levi);
}

void drotacija(struct drvo **p){
	struct drvo *poma,*pomb;
	poma=*p;
	pomb=poma->levi;
	poma->levi=pomb->desni;
	pomb->desni=poma;
	*p=pomb;
	poma->balans=dubina(poma->desni)-dubina(poma->levi);
	pomb->balans=dubina(pomb->desni)-dubina(pomb->levi);
}


int dodaj(struct drvo **p,char *ime,int opesm,int onast,int opev){
	struct drvo *t=*p;
	int ink,rez=0;
	if(t==NULL){
		novi(t);
		if(t==NULL){
			printf("greska pri alokaciji\n");
		    exit(0);
	    }
	    t->ime=(char*)malloc(strlen(ime)+1);
	    t->kom=(char*)malloc(9);
	    strcpy(t->ime,ime);
	    if( opev > 5) strcpy(t->kom,"Uspesan");
	    else strcpy(t->kom,"Neuspesan");
	    t->opev=opev;
	    t->onast=onast;
	    t->opesm=opesm;
	    
	    t->balans=0;
	    rez=1;
	}
	else{
		if( ((opesm+opev+onast)/3.0) > (t->opesm+t->onast+t->opev)/3.0) ink=dodaj(&(t->desni),ime,opesm,onast,opev);
		else ink=-dodaj(&(t->levi),ime,opesm,onast,opev);
		t->balans+=ink;
		
		if(ink!=0 && t->balans!=0){
			if(t->balans < -1){
				if(t->levi->balans < 0) drotacija(&t);
				else{
					lrotacija(&(t->levi)); drotacija(&t);
				}
			}
			else if(t->balans > 1){
				if(t->desni->balans >0) lrotacija(&t);
				else{
					drotacija(&(t->desni)); lrotacija(&t); 
				}
			}
			else rez=1;
		}
	}
	*p=t;
	return rez;
}

struct drvo* napravi(){
	struct drvo *p=NULL;
	int N,opev,opesm,onast,i;
	char ime[20];
	printf("Unesi broj N");
	scanf("%d",&N);
	for(i=0;i<N;i++){
		scanf("%s",ime);
		scanf("%d",&opesm);
		scanf("%d",&onast);
		scanf("%d",&opev);
		dodaj(&p,ime,opesm,onast,opev);
	}
	return p;
}

void ispis(struct drvo *p){
	if(p){
		ispis(p->levi);
		printf("%s %d %d %d %s",p->ime,p->opesm,p->onast,p->opev,p->kom);
		ispis(p->desni);
	}
}

struct drvo* nadji(struct drvo *p){
	while(p->levi!=NULL) p=p->levi;
	return p;
}

void pobednik(struct drvo *p,struct drvo **min,int ocena){
	if(p){
		if((abs(ocena-p->opev)) < (abs(ocena-(*min)->opev))) *min=p;
		pobednik(p->levi,min,ocena);
		pobednik(p->desni,min,ocena);
	}
}
		
	
	
	

main(){
	struct drvo *p,*min;
	int ocena;
	p=napravi();
	ispis(p);
	printf("Unesi ocenu \n");
	scanf("%d",&ocena);
	min=nadji(p);
	pobednik(p,&min,ocena);
	printf("%s %d %d %d %s",min->ime,min->opesm,min->onast,min->opev,min->kom);
}
		
				
				
				
				
				
				
