#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define novi(x) x=(struct lista *)malloc(sizeof(struct lista))
#define blok(x) x=(struct dete *)malloc(sizeof(struct dete))

struct dete
{
	char *ime;
	int broj;
};

struct lista
{
	struct dete *podatak;
	struct lista *sledeci;
};

struct lista *dodaj(struct lista *glava, struct dete *s)
{
	struct lista *pom,*new;

	novi(new);
	if(!new)
	{
		printf("Greska pri alokaciji.");
		exit(0);
	}
	new->podatak=(struct dete *)malloc(sizeof(struct dete));
	new->podatak=s;

	if (glava==NULL)
	{
		glava=new;
		new->sledeci=glava;
	}
	else
	{
		pom=glava;
		while (pom->sledeci!=glava) pom=pom->sledeci;
		pom->sledeci=new;
		new->sledeci=glava;
	}
	return glava;
}

struct lista *form(FILE *f,int n)
{
	struct lista *glava=NULL;
	struct dete *de;
	int i;
	char s[100];
	
	for(i=0;i<n;i++)
	{
		blok(de);
		if(!de)
		{
			printf("Greska pri alokaciji.");
			exit(0);
		}
		fgets(s,100,f);
		de->ime=(char *)malloc(strlen(s)+1);
		strcpy(de->ime,s);
		
		fscanf(f,"%d",&de->broj);
		fgetc(f);
		
		glava=dodaj(glava,de);
		printf("dodao <%d>\n",i+1);
	}
	return glava;
}

void ispis(struct lista *glava,FILE *f)
{
	struct lista *p=glava;
	//struct dete *de;

	do
	{
		//de=p->podatak;
		fprintf(f,"%s",p->podatak->ime);
		fprintf(f,"%d",p->podatak->broj);
		fprintf(f,"\n");
		p=p->sledeci;
	}while(p!=glava);
}

void zaustavi(struct lista *p,int k)
{
	struct lista *pom=p;
	int br=0;
	for(;;)
	{
		if(br==k)
		{
			printf("%s",pom->podatak->ime);
			break;
		}
		else 
		{
			br++;
			pom=pom->sledeci;
		}
	}
}
	
main(int argc,char *argv[])
{
	struct lista *glava=NULL;
	int k,korak;
	char *ime,*imedete;
	FILE *f,*w;
	
	f=fopen(argv[1],"r");
	w=fopen(argv[2],"w");
	
	if(!f || !w)
	{
		printf("Greska pri alokaciji");
		exit(0);
	}
	
	printf("Unesi broj dece: "); scanf("%d",&k);
	glava=form(f,k);
	ispis(glava,w);
	
	printf("Ime prvog deteta: ");
	getchar();
	gets(ime);
	printf("Broj koraka prvog deteta: ");
	scanf("%d",&korak);
	zaustavi(glava,korak);
	//printf("Ime deteta na kojem se zaustavilo prvo dete je %s\n",imedete);
	
	close(f);
	close(w);
}
