#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define novi(x) x=(struct drvo *)malloc(sizeof(struct drvo))

struct drvo
{
	char *ime;
	int rodjen,umro;
	struct drvo *levo,*desno;
};

struct drvo *dodaj(struct drvo *koren,char *s,int r,int u,int k)
{
	struct drvo *pom,*pom2,*new;
	
	novi(new);
	if(!new)
	{
		printf("Greska pri alokaciji.");
		exit(0);
	}
	strcpy(new->ime,s);
	new->rodjen=r;
	new->umro=u;
	new->levo=new->desno=NULL;
	if (koren == NULL) koren=new;
	else
	{
		pom=koren;
		while (pom!=NULL)
		{
			pom2=pom;
			if(k > (pom->umro - pom->rodjen)) pom=pom->desno;
			else pom=pom->levo;
		}
		if (k >(pom2->umro - pom2->rodjen)) pom2->desno=new;
		else pom2->levo=new;
	}
	return koren;
}

struct drvo *form(FILE *f,int k)
{
	struct drvo *koren=NULL,*pom;
	int i,ziveo;
	char s[100];
	
	for(i=0;i<k;i++)
	{
		fgets(s,100,f);
		pom->ime=(char *)malloc(strlen(s)+1);
		strcpy(pom->ime,s);
		
		fscanf(f,"%d",&pom->rodjen);
		fscanf(f,"%d",&pom->umro);
		fgetc(f);
		
		ziveo=pom->umro-pom->rodjen;
		
		koren=dodaj(koren,pom->ime,pom->rodjen,pom->umro,ziveo);
	}
	return koren;
}

void ispis(struct drvo *koren)
{
	struct drvo *p=koren;
	if (p!=NULL)
	{
		ispis(p->levo);
		printf("%s",p->ime);
		printf("%d",(p->umro - p->rodjen));
		ispis(p->desno);
	}
}

void ima(struct drvo *koren,int G, int broj)
{
	struct drvo *p=koren,*pom;

	if ((p->umro - p->rodjen) > G) 
	{
		ima(p->desno,G,broj++);
		ima(p->levo,G,broj++);
	}
	else ima(p->levo,G,broj);
}

main(int argc,char *argv[])
{
	struct drvo *koren=NULL;
	int n,G,broj;
	FILE *f;
	
	f=fopen(argv[1],"r");
	
	if(!f)
	{
		printf("Greska pri alokaciji");
		exit(0);
	}
	
	printf("Unesi broj naucnika: "); scanf("%d",&n);
	koren=form(f,n);
	ispis(koren);
	
	printf("Unesi G: "); scanf("%d",&G);
	ima(koren,G,broj);
	printf("Ima %d koji su ziveli vise od %d godina",broj,G);
}
