#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define novi(x) x=(struct lista *)malloc(sizeof(struct lista))
#define blok(x) x=(struct biro *)malloc(sizeof(struct biro))

struct biro
{
	char *ime,*mesto;
	int sprema,sifra;
};

struct lista
{
	struct biro *podatak;
	struct lista *sledeci;
};

void ispis(struct lista *glava,FILE *f)
{
	struct lista *p=glava;
	struct biro *pom;
	if(p!=NULL)
	{
		do
		{
			pom=p->podatak;
			fprintf(f,"%s",pom->ime);
			fprintf(f,"%s",pom->mesto);
			fprintf(f,"%d\n",pom->sprema);
			fprintf(f,"%d\n",pom->sifra);
			fprintf(f,"\n");
			p=p->sledeci;
		}while(p!=NULL);
	}
	else fprintf(f,"Lista je prazna");
}

struct lista *dodaj(struct lista *glava,struct biro *s)
{
	struct lista *new;
	novi(new);
	if(!new)
	{
		printf("Greska pri alokaciji.");
		exit(0);
	}
	new->podatak=(struct biro *)malloc(sizeof(struct biro));
	new->podatak=s;
	new->sledeci=NULL;
	if(glava==NULL) glava=new;
	else
	{
		new->sledeci=glava;
		glava=new;
	}
	return glava;
}
	
struct lista *form(FILE *f,int n)
{
	struct lista *glava=NULL;
	struct biro *bi;
	int i=0;
	char s[100];
	
	//for(i=0;i<n;i++)
	while(i<n)
	{
		blok(bi);
		if(!bi)
		{
			printf("Greska pri alokaciji.");
			exit(0);
		}
		
		fgets(s,100,f);
		bi->ime=(char *)malloc(strlen(s)+3);
		strcpy(bi->ime,s);
		
		fgets(s,100,f);
		bi->mesto=(char *)malloc(strlen(s)+3);
		strcpy(bi->mesto,s);
		
		fscanf(f,"%d",&bi->sprema);
		fscanf(f,"%d",&bi->sifra);
		fgetc(f);
		
		if((bi->sprema >=3) && (bi->sprema <=8))
		{
			glava=dodaj(glava,bi);
			i++;
		}
		else free(bi);
	}
	return glava;
}

int maximum(struct lista *glava,int p)
{
	struct biro *bi;
	struct lista *pom=glava;
	int max=0;
	while (pom!=NULL)
	{
		bi=pom->podatak;
		if(bi->sifra==p)
		{
			if (max < bi->sprema) max=bi->sprema;
			pom=pom->sledeci;
		}
		else pom=pom->sledeci;
	}
	return max;
}

main(int argc,char *argv[])
{
	struct lista *glava=NULL;
	int k,p,maxsprema;
	FILE *f,*w;
	
	f=fopen(argv[1],"r");
	w=fopen(argv[2],"w");
	
	if(!f || !w)
	{
		printf("Greska pri alokaciji");
		exit(0);
	}
	
	printf("Unesi broj k: "); scanf("%d",&k);
	glava=form(f,k);
	ispis(glava,w);
	
	printf("Unesi sifru posla: ");scanf("%d",&p);
	maxsprema=maximum(glava,p);
	printf("Najveca strucna sprema je %d\n",maxsprema);
	
	close(f);
	close(w);
}
