#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct lista{
	char *ime;
	char *mesto;
	int ss;
	int sp;
	struct lista *rep;
} lista;


#define novi(x) x=(lista*)malloc(sizeof(lista))


void dodaj(lista **p, char *ime, char *mesto, int ss, int sp){
	lista *temp;
	novi(temp);
	if(!temp){
		printf("Greska pri alokaciji memorije\n");
		exit(0);
	}
	temp->ime=(char*)malloc(strlen(ime)+1);
	strcpy(temp->ime,ime);
	temp->mesto=(char*)malloc(strlen(mesto)+1);
	strcpy(temp->mesto,mesto);
	temp->ss=ss;
	temp->sp=sp;
	if(!(*p)){
		temp->rep=NULL;
		*p=temp;
	}
	else {
		temp->rep=*p;
		*p=temp;
	}
}


void ispis(lista *p){
	if(p){
		while(p){
			printf("%s %s %d %d\n",p->ime,p->mesto,p->ss,p->sp);
			p=p->rep;
		}
	}
	else printf("LISTA JE PRAZNA\n");
}


lista *form(){
	lista *p=NULL;
	int ss,sp,i,k;
	char ime[30], mesto[20];
	scanf("%d",&k);
	getchar();
	for (i=0;i<k;i++){
		gets(ime);
		gets(mesto);
		scanf("%d",&ss);
		scanf("%d",&sp);
		getchar();
		if((ss<3) || (ss>8)) i--;
		else dodaj(&p,ime,mesto,ss,sp);
	}
	return p;
}


int strucnasprema(lista *p, int sp){
	lista *pom, *max;
	pom=p;
	if (p){
		while (pom){
			if (pom->sp == sp){
				max=pom;
				break;
			}
			else pom=pom->rep;
		}
		while (p){
			if((p->sp == sp) && (p->ss > max->ss)) max=p;
			p=p->rep;
		}
		return max->ss;
	}
	else return 0;
}

	
void brisi(lista **p,int k){	
	lista *pr, *tr;
	pr=NULL;
	tr=*p;
	while(tr){
		if(tr->ss < k) {
			if(!pr) {
				*p=tr->rep;
				free(tr);
				tr=*p;
			}
			else {
				pr->rep=tr->rep;
				free(tr);
				tr=pr->rep;
			}
		}
		else {
			pr=tr;
			tr=tr->rep;
		}
	}
}
		

void azur(lista **p){
	lista *pom;
	pom=*p;
		while (*p) {
			brisi(&(*p),strucnasprema(*p,(*p)->sp));
			*p=(*p)->rep;
	}
}

	
	
void main(){	
	lista *p;
	int sp;
	p=form();
	ispis(p);
	printf("Unesi sifru posla\n");
	scanf("%d",&sp);
	printf("Za sifru posla %d najveca s.s. je %d\n", sp, strucnasprema(p,sp));
	azur(&p);
	ispis(p);
}
	
