#include <stdio.h>
#include <string.h>
#include <stdlib.h>

struct drvo{
	char *ime;
	int opesme;
	int onast;
	int opevanja;
	char *kom;
	struct drvo *levi, *desni;
	int balans ;
};

#define novi(x) x=(struct drvo*)malloc(sizeof(struct drvo))

int dubina(struct drvo *p){
	int dd=0, dl=0;
	if(p){
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		if(dd>dl) return ++dd;
		else return ++dl;
	}
	else return 0;
}
void lrotacija(struct drvo **p){
struct drvo *poml,*pomd;
poml = *p;
pomd = poml->desni;
poml->desni = pomd->levi;
pomd->levi = poml;
*p=pomd;
poml->balans=dubina(poml->desni)-dubina(poml->levi);
pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);}

void drotacija(struct drvo **p){
struct drvo *poml,*pomd;
pomd = *p;
poml = pomd->levi;
pomd->levi = poml->desni;
poml->desni = pomd;
*p=poml;
poml->balans=dubina(poml->desni)-dubina(poml->levi);
pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);}


int dodaj(struct drvo **p, char *ime, int opesme, int onast, int opevanja){
	struct drvo *t=*p;
	int ink, rez=0;
	if(t==NULL){
		novi(t);
		if(t==NULL){
		printf("greska pri alokaciji");
		exit(0);
	}
	t->ime=(char*)malloc(strlen(ime)+1);
	t->kom=(char*)malloc(9);
	strcpy(t->ime, ime);
	if(opevanja>5) 	strcpy(t->kom,"Uspesan");
	else strcpy(t->kom,"Nespesan");
	t->opevanja=opevanja;
	t->onast=onast;
	t->opesme=opesme;
	
	t->balans=0;
	rez=1;
}
else 
{
	if(((opesme+opevanja+onast)/3.0)>(t->opesme+t->onast+t->opevanja)/3.0)
ink=dodaj(&(t->desni), ime, opesme,onast,opevanja);
else ink=-dodaj(&(t->levi), ime ,opesme, onast, opevanja);
t->balans+=ink;
if (ink!=0 && t->balans!=0){
	if(t->balans <-1){
		if(t->levi->balans<0) drotacija(&t);
		else{
			lrotacija(&(t->levi)); drotacija(&t);
		}
	}
	else if (t->balans>1){
		if(t->desni->balans>0) lrotacija(&t);
		else{
			drotacija(&(t->desni)); lrotacija(&t);
		}
	}
	
	else rez=1;
}
}
*p=t;
return rez;
}

struct drvo* form(){
	struct drvo *p=NULL;
	int n,opevanja, opesme,onast,i;
	char ime[30];
	printf("Unesi broj ");
	scanf("%d",&n);
	for(i=0; i<n;i++){
		scanf("%s", ime);
		scanf("%d",&opesme);
		scanf("%d", &onast);
		scanf("%d", &opevanja);
		dodaj(&p,ime,opesme,onast,opevanja);
	}
	
return p;
}

void ispis(struct drvo *p){
	if(p){
		ispis(p->levi);
		printf("%s %d %d %d", p->ime, p->opesme, p->onast, p->opevanja);
		ispis(p->desni);
}
}
 

main(){
	struct drvo *p;
	p=form();
	ispis(p);
}


	
