#include<stdio.h>
#include<stdlib.h>
#include<string.h>

struct drvo
{char *ime;
 int pesma;
 int nastup;
 int pevanje;
 float srednja;
 char komentar[10];
 int balans;
 struct drvo *levi,*desni;
};

#define novi(x) x=(struct drvo*)malloc(sizeof(struct drvo))

int dubina(struct drvo *p)
{int dl=0,dd=0;
 if(p)
 {if(p->levi) dl=dubina(p->levi);
  if(p->desni) dd=dubina(p->desni);
  if(dl>dd) return ++dl;
  else return ++dd;
  }
else return 0;
}

void lrotacija(struct drvo **t)
{struct drvo *poml,*pomd;
 poml=*t;
 pomd=poml->desni;
 poml->desni=pomd->levi;
 pomd->levi=poml;
 *t=pomd;
poml->balans=dubina(poml->desni)-dubina(poml->levi);
pomd->balans=dubina(pomd->desni)-dubina(poml->levi);
}

 void drotacija(struct drvo **t)
{ struct drvo *poml,*pomd;
 pomd=*t;
 poml=pomd->levi;
 pomd->levi=poml->desni;
 poml->desni=pomd;
 *t=poml;
poml->balans=dubina(poml->desni)-dubina(poml->levi);
pomd->balans=dubina(pomd->desni)-dubina(poml->levi);
}

int dodaj(struct drvo **p,char ime[50],int pesma,int nastup,int pevanje)
{ int inkrement,rezultat=0;
  struct drvo *t=*p;
 
 if(t==NULL)
 {novi(t);
   if(t==NULL)
    {printf("Greska\n");
     exit(0);
    }
  t->ime=(char*)malloc(strlen(ime)+1);
  strcpy(t->ime,ime);
  t->pesma=pesma;
  t->nastup=nastup;
  t->pevanje=pevanje;
  t->srednja=(pesma+nastup+pevanje)/3.0;
  if(pevanje>5) strcpy(t->komentar,"Uspesan");
  else strcpy(t->komentar,"Neuspesan");
  t->balans=0;
  t->levi=t->desni=NULL;
  rezultat=1;
 }
 else 
     { if(((pesma+nastup+pevanje)/3) > (t->srednja) ) inkrement=dodaj(&(t->desni),ime,pesma,nastup,pevanje);
       else inkrement=-dodaj(&(t->levi),ime,pesma,nastup,pevanje);
       t->balans+=inkrement;
   
   if(inkrement!=0 && t->balans!=0)
     { if(t->balans<-1)  
       { if(t->levi->balans<0) drotacija(&t);
         else
           {lrotacija(&(t->levi));
            drotacija(&t);
           }
        }
      else  if(t->balans>1)  
       { if(t->desni->balans>0) lrotacija(&t);
         else
           {drotacija(&(t->desni));
            lrotacija(&t);
           }
        } 
else rezultat=1;
}
}
(*p)=t;
return rezultat;
}

struct drvo* form(FILE *f)
{ struct drvo *p=NULL;
  int n,i,pesma,nastup,pevanje;
  char ime[50];
  fscanf(f,"%d\n",&n);
  for(i=0;i<n;i++)
  {fgets(ime,50,f);
   fscanf(f,"%d\n",&pesma);
   fscanf(f,"%d\n",&nastup);
   fscanf(f,"%d\n",&pevanje);
   dodaj(&p,ime,pesma,nastup,pevanje);
   }
return p;
}

void ispis(struct drvo *p)
{ if(p)
   { if(p->desni) ispis(p->desni);
     printf("%s\t%d\t%d\t%d\t%f\t%s\t%d\n",p->ime,p->pesma,p->nastup,p->pevanje,p->srednja,p->komentar,p->balans);
     if(p->levi) ispis(p->levi);
    }
}

main(int argc,char *argv[])
{struct drvo *p;
 FILE *f;
 //char ime1[50];
 //char ime2[50]; 
 f=fopen(argv[1],"r");
 if(!f)
  {printf("Greska\n");
   exit(0);
  }
 p=form(f);
 printf("Podaci su:\n");
 ispis(p);
 /*printf("Unesi 2 imena:\n");
   gets(ime1);
   strcat(ime,"\n");
   gets(ime2);
   strcat(ime,"\n");*/
} 

   

 
