#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#define novi(x) x = (struct prijava *)malloc(sizeof(struct prijava))

int ucitan;

struct prijava{
	char ime[50];
	char mesto[50];
	int strucna_sprema;
	int sifra_posla;
	struct prijava *rep;
};

int najveca(struct prijava *glava, int sifra){
	int sifra_posla, najveca_strucna = 0;
	sifra_posla = sifra;
	while(glava){
		if((glava->strucna_sprema > najveca_strucna)&&(glava->sifra_posla == sifra_posla))
			najveca_strucna = glava->strucna_sprema;
		glava = glava->rep;
	}
	return najveca_strucna;
}

void izbrisi(struct prijava **glava){
	struct prijava *temp, *pom1, *pom2;
	pom1 = *glava;
	pom2 = pom1;
	while(pom2->strucna_sprema < najveca(*glava, pom2->sifra_posla))
	{
		pom1 = pom2->rep;
		free(pom2);
		pom2 = pom1;
	}
	while(pom2->rep)
	{
		if((pom2->rep->strucna_sprema < najveca(*glava, pom2->rep->sifra_posla)))
		{
			temp = pom2->rep;
			pom2->rep = temp->rep;
			free(temp);
		}
		else
			pom2 = pom2->rep;
	}
	*glava = pom1;
	return;
}

void dodaj(struct prijava **glava){
	struct prijava *temp;
	char s[50];
	novi(temp);
	
	getchar();
	gets(s);
	strcpy(temp->ime, s);
	gets(s);
	strcpy(temp->mesto, s);
	scanf("%d%d",&temp->strucna_sprema,&temp->sifra_posla);
	
	if((temp->strucna_sprema >2) && (temp->strucna_sprema < 9))
	{
		temp->rep = *glava;
		*glava = temp;//ako zadovoljava
		ucitan = 0;
	}
	else
	{
		ucitan = -1;//ako ne zadovoljava
	}
}

struct prijava *formiraj(){
	struct prijava *glava;
	glava = NULL;
	int i, k;
	scanf("%d",&k);//broj prijava

	for(i = 0; i < k; i++)
	{
		dodaj(&glava);
		i = i + ucitan;//koliko treba ucitati
	}
	return glava;
}

void ispis(struct prijava *glava){
	while(glava){
		printf("%s\t%s\t%d\t%d\n", glava->ime, glava->mesto, glava->strucna_sprema, glava->sifra_posla);
		glava = glava->rep;
	}
}

int main(){
	struct prijava *glava;
	int sifra_posla;	
	glava = formiraj();
	printf("\nPrvobitna\n\n");
	ispis(glava);
	scanf("%d",&sifra_posla);
	printf("\nZa sifru %d najveca %d\n",sifra_posla, najveca(glava,sifra_posla));
	izbrisi(&glava);
	printf("\nPosle brisanja\n\n");
	ispis(glava);
	return(0);
}
