#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct lista {
	char *ime;
	char *mesto;
	int ss;
	int sp;
	struct lista *rep;
};

#define novi(x) x = (struct lista *)malloc(sizeof(struct lista))

void dodaj(struct lista **p, char *ime, char *mesto, int ss, int sp) {
	struct lista *temp;
	novi(temp);
	if (!temp) {
		printf("Greska pri alokaciji memorije.\n");
		exit(0);
	}
	temp->ime = (char *)malloc(strlen(ime) + 1);
	strcpy(temp->ime, ime);
	temp->mesto = (char *)malloc(strlen(mesto) + 1);
	strcpy(temp->mesto, mesto);
	temp->ss = ss;
	temp->sp = sp;
	if (!(*p)) {
		temp->rep = NULL;
		*p = temp;
	}
	else {
		temp->rep = *p;
		*p = temp;
	}
}

void ispis(struct lista *p) {
	if (p) {
		while (p) {
			printf("%s | %s | %d | %d\n", p->ime, p->mesto, p->ss, p->sp);
			p = p->rep;
		}
	}
	else printf("Lista je prazna.\n");
}

struct lista *form() {
	struct lista *p = NULL;
	int k, ss, sp, i;
	char ime[50], mesto[50];
	scanf("%d", &k);
	getchar();
	for (i = 0; i < k; i++) {
		gets(ime);
		gets(mesto);
		scanf("%d", &ss);
		scanf("%d", &sp);
		getchar();
		if ((ss < 3) || (ss > 8)) i--;
		else dodaj(&p, ime, mesto, ss, sp);
		}
	return p;
}

int ssprr(struct lista *p, int sp) {
	struct lista *max, *pom;
	pom = p;
	if (p) {
		while (pom) {
			if (pom->sp == sp) {
				max = pom;
				break;
			}
			else pom = pom->rep;
		}
		while (p) {
			if ((p->sp == sp) && (p->ss > max->ss)) max = p;
			p = p->rep;
		}
		return max->ss;
	}
	else return 0;
} 

void obrisi(struct lista **p, int test) {
	struct lista *preth, *tren;
	preth = NULL;
	tren = *p;
	while (tren) {
		if (tren->ss < test) {
			if (!preth) {
				*p = tren->rep;
				free(tren);
				tren = *p;
			}
			else {
				preth->rep = tren->rep;
				free(tren);
				tren = preth->rep;
			}
		}
		else {
			preth = tren;
			tren = tren->rep;
		}
	}
}

void azuriraj(struct lista **p) {
	obrisi(&(*p), ssprr(*p, (*p)->sp));
}
	
main () {
	struct lista *p;
	int sp;
	p = form();
	ispis(p);
	printf("Unesi sifru posla: ");
	scanf("%d", &sp);
	printf("Za sifru posla %d, najveca strucna sprema je %d\n", sp, ssprr(p, sp));
	azuriraj(&p);
	ispis(p);
}
