#include<stdio.h>
#include<stdlib.h>
#include<string.h>

typedef struct cvorS
{
	char *ime;
	int ocenaT, ocenaN,ocenaPevanja, balans;
	float prosek;
	char *uspeh;
	struct cvorS *levi, *desni;
}cvor;

#define novi(x) x = (cvor*)malloc(sizeof(cvor));

int dubina(cvor *p)
{
	int dd = 0, dl = 0;
	if(p)
	{
		if(p->levi) dl = dubina(p->levi);
		if(p->desni) dd = dubina(p->desni);
		if(dl>dd) return ++dl;
		else      return ++dd;
	}
	else return 0;
}

void lrotacija(cvor **t)
{
	cvor *poml, *pomd;
	*t = poml;
	pomd = poml->desni;
	poml->desni = pomd->levi;
	pomd->levi = poml;
	pomd = *t;
	
	poml->balans = dubina(poml->desni) - dubina(poml->levi);
	pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
}

void drotacija(cvor **t)
{
	cvor *poml, *pomd;
	*t = pomd;
	poml = pomd->levi;
	pomd->levi = poml->desni;
	poml->desni = pomd;
	poml = *t;
	
	poml->balans = dubina(poml->desni) - dubina(poml->levi);
	pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
}

int dodaj(cvor **koren, char *s,int tezina,int nastup, int pevanje,float srvr,char *uspesnost)
{
	int inkrement,rezultat = 0;
	cvor *t;
	t = *koren;
	if (t == NULL)
	{
		novi(t);
		if(t == NULL)
		{
			printf("Greska pri alokaciji memorije\n");
			exit(0);
		}
		
		t->ime = (char*)malloc(strlen(s)+1);
		strcpy(t->ime,s);
		t->ocenaT = tezina;
		t->ocenaN = nastup;
		t->ocenaPevanja = pevanje;
		t->prosek = srvr;
		t->uspeh = uspesnost;
		t->balans = 0;
		rezultat = 1;
	}
	else
	{
		if( srvr > t->prosek) inkrement = dodaj(&(t->desni),s,tezina,nastup,pevanje,srvr,uspesnost);
		else inkrement = -dodaj(&(t->levi),s,tezina,nastup,pevanje,srvr,uspesnost);
		
		t->balans += inkrement;
		
		if(inkrement != 0 && t->balans != 0)
		{
			if(t->balans < -1)
			{
				if(t->levi->balans<0) drotacija(&t);
				else
				{
					lrotacija(&(t->levi));
					drotacija(&t);
				}
			}
			else if (t->balans > 1)
			{
				if(t->desni->balans>0) lrotacija(&t);
				else
				{
					drotacija(&(t->desni));
					lrotacija(&t);
				}
			}
			else rezultat = 1;
		}
	}
	*koren = t;
}

float srednja_vrednost(cvor *p,int T,int N,int P)
{
	cvor *t;
	t = p;
	int suma = 0;
	float srednja;
	suma = T + N + P;
	srednja = suma/3;
}
		

cvor *form(int n)
{
	cvor *pr = NULL;
	int i,T,N,P;
	char s[50], uspesnost[20];
	float sr;
	for(i=0;i<n;i++)
	{
		printf("Unesi ime: ");
		scanf("%s",s);
		printf("Unesi ocene za tezinu, nastup, prvanje:\n");
		scanf("%d %d %d",&T,&N, &P);
		sr = srednja_vrednost(pr,T,N,P);
		dodaj(&pr,s,T,N,P,sr,uspesnost);
	}
	return pr;
}

void ispis(cvor *p)
{
	if(p)
	{
		ispis(p->levi);	
		printf("Ime kandidata i srednja ocena: %s , %f",p->ime, p->prosek);
		ispis(p->desni);
	}
}	

				
		
main()
{
	cvor *koren = NULL;
	int n;
	printf("Unesite koliko takmicara zelite: "); scanf("%d",&n);
	koren = form(n);
	ispis(koren);
	
}

