#include<stdio.h>
#include<stdlib.h>

struct drvo
{
	char ime[30];
	unsigned int tezina,nastup,pevanje;
	double ocena;
	short boja,komentar,publika;
	struct drvo *roditelj,*levi,*desni;
};

enum{CRVENA,CRNA};
enum{NEUSPESAN,USPESAN};

void lrotacija(struct drvo **p)
{
	struct drvo *pom,*t;
	pom=(*p);
	t=pom->desni;
	pom->desni=t->levi;
	if(pom->desni) pom->desni->roditelj=pom;
	t->roditelj=pom->roditelj;
	if(pom->roditelj)
		if(pom->roditelj->levi==pom) pom->roditelj->levi=t;
		else pom->roditelj->desni=t;
	pom->roditelj=t;
	t->levi=pom;
	(*p)=t;
}

void drotacija(struct drvo **p)
{
	struct drvo *pom, *t;
	pom=(*p);
	t=pom->levi;
	pom->levi=t->desni;
	if(pom->levi) pom->levi->roditelj=pom;
	t->roditelj=pom->roditelj;
	if(t->roditelj)
		if(pom==t->roditelj->levi) t->roditelj->levi=t;
		else t->roditelj->desni=t;
	t->desni=pom;
	pom->roditelj=t;
	(*p)=t;
}

void sredi(struct drvo **p, struct drvo *z)
{
	struct drvo *ujak,*deda;
	while(z->roditelj && z->roditelj->boja==CRVENA)
{
	if(z->roditelj==z->roditelj->levi)
	{
		ujak=z->roditelj->roditelj->desni;
		if(ujak && ujak->boja==CRVENA)
		{
			z->roditelj->boja=CRNA;
			ujak->boja=CRNA;
			ujak->roditelj->boja=CRVENA;
			z=ujak->roditelj;
		}
		else
		{
			if(z==z->roditelj->desni)
			{
				z=z->roditelj;
				lrotacija(&z);
				if(!z->roditelj) (*p)=z;
				z=z->levi;
			}
			z->roditelj->boja=CRNA;
			deda=z->roditelj->roditelj;
			deda->boja=CRVENA;
			drotacija(&deda);
			if(!deda->roditelj) (*p)=deda;
		}
	}
	else
	{
		ujak=z->roditelj->roditelj->levi;
		if(ujak && ujak->boja==CRVENA)
		{
			ujak->boja=CRNA;
			z->roditelj->boja=CRNA;
			ujak->roditelj->boja=CRVENA;
			z=z->roditelj->roditelj;
		}
		else
		{
			if(z==z->roditelj->levi)
			{
				z=z->roditelj;
				drotacija(&z);
				if(!z->roditelj) (*p)=z;
				z=z->desni;
			}
			z->roditelj->boja=CRNA;
			z->roditelj->roditelj->boja=CRVENA;
			deda=z->roditelj->roditelj;
			lrotacija(&deda);
			if(!deda->roditelj) (*p)=deda;
		}
	}
}
	(*p)->boja=CRNA;
}

void dodaj(struct drvo **p, struct drvo *q)
{
	struct drvo *pom,*t;
	pom=(*p);
	t=NULL;
	while(pom)
	{
		t=pom;
		if(pom->ocena>q->ocena) pom=pom->levi;
		else pom=pom->desni;
	}
	q->roditelj=t;
	if(!t) (*p)=q;
	else
		if(t->ocena>q->ocena) t->levi=q;
		else t->desni=q;
	sredi(p,q);
}

struct drvo *unos()
{
	struct drvo *p,*q;
	int n;
	p=NULL;
	printf("Unesite broj kandidata: ");
	scanf("%d",&n);
	while(n)
	{
		q=(struct drvo *)malloc(sizeof(struct drvo));
		printf("Ime: ");
		scanf("%s",q->ime);
		printf("Ocena tezine pesme: ");
		scanf("%d",&(q->tezina));
		printf("Ocena nastupa: ");
		scanf("%d",&(q->nastup));
		printf("Ocena pevanja: ");
		scanf("%d",&(q->pevanje));
		q->publika=0;
		q->boja=CRVENA;
		q->levi=q->desni=NULL;
		q->ocena=(double)(q->tezina+q->pevanje+q->nastup)/3.0;
		if(q->pevanje>5) q->komentar=USPESAN;
		else q->komentar=NEUSPESAN;
		dodaj(&p,q);
		n--;
	}
	return p;
}

void stampaj(struct drvo *p)
{
	if(p)
	{
	stampaj(p->desni);
	printf("Ime: %s\tTezina: %2d\t Nastup: %2d\t Pevanje: %2d\t Prosek: %4.2f\t",p->ime,p->tezina,p->nastup,p->pevanje,p->ocena);
	if(p->komentar) printf("Komentar: USPESAN\n");
	else printf("Komentar: NEUSPESAN\n");
	stampaj(p->levi);
	}
}

void publika(struct drvo *p, char *a, int dodato)
{
	if(p)
	{
		if(!(strcmp(p->ime,a)))
		{
		p->ocena=(3*p->ocena+dodato)/4.0;
		p->publika=156;
		}
		publika(p->levi,a,dodato);
		publika(p->desni,a,dodato);
	}
}

void brisi(struct drvo *p, struct drvo **q)
{
	struct drvo *t;
	if(p)
	{
	if((p->komentar==USPESAN)||((p->publika)&&(p->ocena>5)))
	{
		t=(struct drvo *)malloc(sizeof(struct drvo));
		strcpy(t->ime,p->ime);
		t->ocena=p->ocena;
		t->nastup=p->nastup;
		t->pevanje=p->pevanje;
		t->tezina=p->tezina;
		t->komentar=p->komentar;
		t->publika=p->publika;
		t->boja=CRVENA;
		t->levi=t->desni=t->roditelj=NULL;
		dodaj(q,t);
		brisi(p->levi,q);
		brisi(p->desni,q);
	}
	else 
	{
		brisi(p->levi,q);
		brisi(p->desni,q);
	}
	}
}

void odredi(struct drvo *p, int oc,int *broj)
{
	if(p)
	{
		if(abs(oc-p->pevanje)<abs(oc-(*broj))) (*broj)=p->pevanje;
		odredi(p->levi,oc,broj);
		odredi(p->desni,oc,broj);
	}
}

void nadji(struct drvo *p,struct drvo *q, int pob)
{
	if(p)
	{
		if(p->pevanje==pob) (*q)=(*p);
		nadji(p->levi,q,pob);
		nadji(p->desni,q,pob);
	}
}

main()
{
	struct drvo *p=NULL,*q=NULL,r;
	char a[30];
	int oc,pob;
	p=unos();
	stampaj(p);
	printf("Unesi dva imena\n");
	scanf("%s",a);
	publika(p,a,5);
	scanf("%s",a);
	publika(p,a,10);
	brisi(p,&q);
	printf("Sale Popovic: Dalje idu\n");
	stampaj(q);
	printf("Unesi ocenu pevanja: ");
	scanf("%d",&oc);
	pob=q->pevanje;
	odredi(q,oc,&pob);
	nadji(q,&r,pob);
	printf("Pobednik je Ime: %s\tTezina: %2d\t Nastup: %2d\t Pevanje: %2d\t Prosek: %4.2f\t",r.ime,r.tezina,r.nastup,r.pevanje,r.ocena);
}









